#ifndef DEBYER__UTILS__H__
#define DEBYER__UTILS__H__

// C++ utils

#include <string>
#include <sstream>
#include <iostream>
#include <math.h>
#include <cstdlib>


class StdDev
{
public:
    StdDev() : n(0), mean(0.), S(0.) {}
    std::string str() { return static_cast<std::ostringstream&>(
              std::ostringstream() << mean << " +- " << get_stddev()).str(); }
    double get_variance() const { return S / (n - 1); }
    double get_stddev() const { return sqrt(get_variance()); }
    double get_mean() const { return mean; }
    double get_n() const { return n; }
    void add_x(double x) 
    { 
        ++n; 
        double delta = x - mean; 
        mean += delta / n;
        S += delta * (x - mean);
    }

private:
    int n;
    double mean, S;
};

inline
int open_atoms_file(const char* fn, xyz_name **coords, dbr_pbc& pbc,
                    bool relative_coords = true)
{
    return read_atoms_c(fn, coords, &pbc, relative_coords);
}

inline int iround(double d) { return static_cast<int>(floor(d+0.5)); }

#endif // DEBYER__UTILS__H__
